{**************************************************************}
{* "MOSFET and resistor NOR" unit for LogicGates9 application *}
{**************************************************************}

unit nor1;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls, Grids, common;

type
  {********}
  { TfNor1 }
  {********}
  TfNor1 = class(TForm)
    stTitle, StaticText1: TStaticText;
    edGate, edMosfet: TMemo;
    Label1, Label2, Label3, Label4, Label5: TLabel;
    laM1, laM2, laM1Status, laM2Status: TLabel;
    Image1, Image2, Image3, imSwitch1, imSwitch2: TImage;
    Shape1, Shape10, Shape13, Shape18, Shape19, Shape2, Shape21, Shape22: TShape;
    Shape23, Shape26, Shape27, Shape28, Shape29, Shape3, Shape30, Shape35: TShape;
    Shape36, Shape37, Shape39, Shape40, Shape41, Shape5, Shape6, Shape7, Shape8, Shape9: TShape;
    shSwitch1H, shSwitch1V, shSwitch2H, shSwitch2V: TShape;
    shLed1, shLed2, shLed3: TShape;
    sgTruthTable: TStringGrid;
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure imSwitch1Click(Sender: TObject);
    procedure imSwitch2Click(Sender: TObject);
  private
    rdSwitchA, rdSwitchB: TSwitch;
    rdLedA, rdLedB, rdLedOut: TLed;
    rdMosfet1, rdMosfet2: TMosfet;
  end;

var
  fNor1: TfNor1;

implementation

{$R *.lfm}

{********}
{ TfNor1 }
{********}

{ Application start: Initialisations }

procedure TfNor1.FormCreate(Sender: TObject);

begin
  laM1.Caption := StringReplace(laM1.Caption, '1', SUB_1, [rfReplaceAll]);
  laM2.Caption := StringReplace(laM2.Caption, '2', SUB_2, [rfReplaceAll]);
  edMosfet.Text := StringReplace(edMosfet.Text, '1', SUB_1, [rfReplaceAll]);
  edMosfet.Text := StringReplace(edMosfet.Text, '2', SUB_2, [rfReplaceAll]);
  // Switches
  with rdSwitchA do begin
    shSwitchH := shSwitch1H; shSwitchV := shSwitch1V; imSwitch := imSwitch1;
    iPosOffH := shSwitch1H.Top; iPosOffV := shSwitch1V.Top;
    bStatus := False;
  end;
  with rdSwitchB do begin
    shSwitchH := shSwitch2H; shSwitchV := shSwitch2V; imSwitch := imSwitch2;
    iPosOffH := shSwitch2H.Top; iPosOffV := shSwitch2V.Top;
  end;
  // LEDs
  rdLedA.shLed := shLed1;
  rdLedB.shLed := shLed2;
  rdLedOut.shLed := shLed3;
  // MOSFETs
  rdMosfet1.laStatus := laM1Status; rdMosfet1.cChannel := 'N';
  rdMosfet2.laStatus := laM2Status; rdMosfet2.cChannel := 'N';
end;

{ Window show-up: Start the simulation }

procedure TfNor1.FormActivate(Sender: TObject);

begin
  Init(rdSwitchA, rdSwitchB, rdLedA, rdLedB, rdLedOut, rdMosfet1, rdMosfet2);
end;

{ Switch A or B closed/opened: Adapt the simulation }

procedure TfNor1.imSwitch1Click(Sender: TObject);

begin
  SwitchPush(rdSwitchA, rdLedA);
  GateNor1(rdSwitchA, rdSwitchB, rdMosfet1, rdMosfet2, rdLedOut);
end;

procedure TfNor1.imSwitch2Click(Sender: TObject);

begin
  SwitchPush(rdSwitchB, rdLedB);
  GateNor1(rdSwitchA, rdSwitchB, rdMosfet1, rdMosfet2, rdLedOut);
end;

end.

